## NMSettingGsm

NMSettingGsm — Describes GSM/3GPP-based mobile broadband properties

## Functions

NMSetting * | nm_setting_gsm_new ()
const char * | nm_setting_gsm_get_number ()
const char * | nm_setting_gsm_get_username ()
const char * | nm_setting_gsm_get_password ()
const char * | nm_setting_gsm_get_apn ()
const char * | nm_setting_gsm_get_network_id ()
const char * | nm_setting_gsm_get_pin ()
gboolean | nm_setting_gsm_get_home_only ()
const char * | nm_setting_gsm_get_device_id ()
const char * | nm_setting_gsm_get_sim_id ()
const char * | nm_setting_gsm_get_sim_operator_id ()
NMSettingSecretFlags | nm_setting_gsm_get_pin_flags ()
NMSettingSecretFlags | nm_setting_gsm_get_password_flags ()

## Properties

gchar * | apn | Read / Write
gchar * | device-id | Read / Write
gboolean | home-only | Read / Write
gchar * | network-id | Read / Write
gchar * | number | Read / Write
gchar * | password | Read / Write
NMSettingSecretFlags | password-flags | Read / Write
gchar * | pin | Read / Write
NMSettingSecretFlags | pin-flags | Read / Write
gchar * | sim-id | Read / Write
gchar * | sim-operator-id | Read / Write
gchar * | username | Read / Write

## Types and Values

#define | NM_SETTING_GSM_SETTING_NAME
#define | NM_SETTING_GSM_NUMBER
#define | NM_SETTING_GSM_USERNAME
#define | NM_SETTING_GSM_PASSWORD
#define | NM_SETTING_GSM_PASSWORD_FLAGS
#define | NM_SETTING_GSM_APN
#define | NM_SETTING_GSM_NETWORK_ID
#define | NM_SETTING_GSM_PIN
#define | NM_SETTING_GSM_PIN_FLAGS
#define | NM_SETTING_GSM_HOME_ONLY
#define | NM_SETTING_GSM_DEVICE_ID
#define | NM_SETTING_GSM_SIM_ID
#define | NM_SETTING_GSM_SIM_OPERATOR_ID
| NMSettingGsm

## Object Hierarchy

        GObject
        ╰── NMSetting
            ╰── NMSettingGsm

## Description

The NMSettingGsm object is a NMSetting subclass that describes properties that allow connections to 3GPP-based mobile broadband networks, including those using GPRS/EDGE and UMTS/HSPA technology.

## Functions

### nm_setting_gsm_new ()

    NMSetting *
    nm_setting_gsm_new (void);

Creates a new NMSettingGsm object with default values.

#### Returns

the new empty NMSettingGsm object

### nm_setting_gsm_get_number ()

    const char *
    nm_setting_gsm_get_number (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “number” property of the setting

### nm_setting_gsm_get_username ()

    const char *
    nm_setting_gsm_get_username (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “username” property of the setting

### nm_setting_gsm_get_password ()

    const char *
    nm_setting_gsm_get_password (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “password” property of the setting

### nm_setting_gsm_get_apn ()

    const char *
    nm_setting_gsm_get_apn (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “apn” property of the setting

### nm_setting_gsm_get_network_id ()

    const char *
    nm_setting_gsm_get_network_id (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “network-id” property of the setting

### nm_setting_gsm_get_pin ()

    const char *
    nm_setting_gsm_get_pin (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “pin” property of the setting

### nm_setting_gsm_get_home_only ()

    gboolean
    nm_setting_gsm_get_home_only (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “home-only” property of the setting

### nm_setting_gsm_get_device_id ()

    const char *
    nm_setting_gsm_get_device_id (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “device-id” property of the setting

Since: 1.2

### nm_setting_gsm_get_sim_id ()

    const char *
    nm_setting_gsm_get_sim_id (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “sim-id” property of the setting

Since: 1.2

### nm_setting_gsm_get_sim_operator_id ()

    const char *
    nm_setting_gsm_get_sim_operator_id (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the “sim-operator-id” property of the setting

Since: 1.2

### nm_setting_gsm_get_pin_flags ()

    NMSettingSecretFlags
    nm_setting_gsm_get_pin_flags (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the NMSettingSecretFlags pertaining to the “pin”

### nm_setting_gsm_get_password_flags ()

    NMSettingSecretFlags
    nm_setting_gsm_get_password_flags (NMSettingGsm *setting);

#### Parameters

setting | the NMSettingGsm |

#### Returns

the NMSettingSecretFlags pertaining to the “password”

## Types and Values

### NM_SETTING_GSM_SETTING_NAME

    #define NM_SETTING_GSM_SETTING_NAME "gsm"

### NM_SETTING_GSM_NUMBER

    #define NM_SETTING_GSM_NUMBER          "number"

### NM_SETTING_GSM_USERNAME

    #define NM_SETTING_GSM_USERNAME        "username"

### NM_SETTING_GSM_PASSWORD

    #define NM_SETTING_GSM_PASSWORD        "password"

### NM_SETTING_GSM_PASSWORD_FLAGS

    #define NM_SETTING_GSM_PASSWORD_FLAGS  "password-flags"

### NM_SETTING_GSM_APN

    #define NM_SETTING_GSM_APN             "apn"

### NM_SETTING_GSM_NETWORK_ID

    #define NM_SETTING_GSM_NETWORK_ID      "network-id"

### NM_SETTING_GSM_PIN

    #define NM_SETTING_GSM_PIN             "pin"

### NM_SETTING_GSM_PIN_FLAGS

    #define NM_SETTING_GSM_PIN_FLAGS       "pin-flags"

### NM_SETTING_GSM_HOME_ONLY

    #define NM_SETTING_GSM_HOME_ONLY       "home-only"

### NM_SETTING_GSM_DEVICE_ID

    #define NM_SETTING_GSM_DEVICE_ID       "device-id"

### NM_SETTING_GSM_SIM_ID

    #define NM_SETTING_GSM_SIM_ID          "sim-id"

### NM_SETTING_GSM_SIM_OPERATOR_ID

    #define NM_SETTING_GSM_SIM_OPERATOR_ID "sim-operator-id"

### NMSettingGsm

    typedef struct _NMSettingGsm NMSettingGsm;

## Property Details

### The `“apn”` property

      “apn”                      gchar *

The GPRS Access Point Name specifying the APN used when establishing a data session with the GSM-based network. The APN often determines how the user will be billed for their network usage and whether the user has access to the Internet or just a provider-specific walled-garden, so it is important to use the correct APN for the user's mobile broadband plan. The APN may only be composed of the characters a-z, 0-9, ., and - per GSM 03.60 Section 14.9.

Flags: Read / Write

Default value: NULL

### The `“device-id”` property

      “device-id”                gchar *

The device unique identifier (as given by the WWAN management service) which this connection applies to. If given, the connection will only apply to the specified device.

Flags: Read / Write

Default value: NULL

Since: 1.2

### The `“home-only”` property

      “home-only”                gboolean

When `TRUE`, only connections to the home network will be allowed. Connections to roaming networks will not be made.

Flags: Read / Write

Default value: FALSE

### The `“network-id”` property

      “network-id”               gchar *

The Network ID (GSM LAI format, ie MCC-MNC) to force specific network registration. If the Network ID is specified, NetworkManager will attempt to force the device to register only on the specified network. This can be used to ensure that the device does not roam when direct roaming control of the device is not otherwise possible.

Flags: Read / Write

Default value: NULL

### The `“number”` property

      “number”                   gchar *

Number to dial when establishing a PPP data session with the GSM-based mobile broadband network. Many modems do not require PPP for connections to the mobile network and thus this property should be left blank, which allows NetworkManager to select the appropriate settings automatically.

Flags: Read / Write

Default value: NULL

### The `“password”` property

      “password”                 gchar *

The password used to authenticate with the network, if required. Many providers do not require a password, or accept any password. But if a password is required, it is specified here.

Flags: Read / Write

Default value: NULL

### The `“password-flags”` property

      “password-flags”           NMSettingSecretFlags

Flags indicating how to handle the “password” property.

Flags: Read / Write

### The `“pin”` property

      “pin”                      gchar *

If the SIM is locked with a PIN it must be unlocked before any other operations are requested. Specify the PIN here to allow operation of the device.

Flags: Read / Write

Default value: NULL

### The `“pin-flags”` property

      “pin-flags”                NMSettingSecretFlags

Flags indicating how to handle the “pin” property.

Flags: Read / Write

### The `“sim-id”` property

      “sim-id”                   gchar *

The SIM card unique identifier (as given by the WWAN management service) which this connection applies to. If given, the connection will apply to any device also allowed by “device-id” which contains a SIM card matching the given identifier.

Flags: Read / Write

Default value: NULL

Since: 1.2

### The `“sim-operator-id”` property

      “sim-operator-id”          gchar *

A MCC/MNC string like "310260" or "21601" identifying the specific mobile network operator which this connection applies to. If given, the connection will apply to any device also allowed by “device-id” and “sim-id” which contains a SIM card provisioined by the given operator.

Flags: Read / Write

Default value: NULL

Since: 1.2

### The `“username”` property

      “username”                 gchar *

The username used to authenticate with the network, if required. Many providers do not require a username, or accept any username. But if a username is required, it is specified here.

Flags: Read / Write

Default value: NULL